library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity TB_ALS is end entity;

architecture a of TB_ALS is
 signal start, t: std_logic := '0'; 
 signal start_ack, SD, SCK, CS: std_logic;
 constant tSIM: delay_length := 35 us;
 constant tP: delay_length := 500 ns;
begin

 slave: entity work.ADC081S021 generic map(tSCL => tP, D_init => x"4D")
                             port map(scl => sck, sda => sd, cs=>cs);
 master: entity work.spi_master port map(t=>t, start=>start, start_ack=>start_ack, cs=>cs, sck=>sck, sdi=>sd);
 -- geaenderter Entity fuer Post-Place & Route Simulation
 --master: entity work.als port map(t=>t, start=>start, start_ack=>start_ack, cs=>cs, sck=>sck, sdi=>sd);

 -- process begin
 -- wait for 0.25*tP; t <= '1';
 -- wait for 0.75*tP; t <= '0';
 -- if now > tSIM then wait; end if;
 -- end process;
 t <= not t after tP/100 when (now < tSIM) else '0';
 
 process begin
  wait for 0.5 us;
  start <= '1' after 200 ns; 
  if start_ack /= '1' then wait until start_ack = '1'; end if;
  start <='0' after 200 ns; 
  if start_ack /= '0' then wait until start_ack = '0'; end if;
  wait for 9 us;
  if now > tSIM then wait; end if;
 end process;
end architecture;
