library ieee;
use ieee.std_logic_1164.all;

entity ps2t_tb is  end entity;

architecture tb of ps2t_tb is
 signal T, I: std_logic:='0';                       -- Takt und Init.-Signal zu entwerfene Schaltung 
 signal send_dev, send_ack, send_pc: std_logic:='0';-- Sende und Sendequittierung 
 signal x_dev, x_pc: std_logic_vector(7 downto 0);  -- Sendedaten
 signal y_dev, y_pc: std_logic_vector(7 downto 0);  -- Empfangsdaten
 signal ps2d, ps2t: std_logic:='Z';		            -- PS/2-Signale mit Pull-up-Element
 signal run_sim: boolean;                           -- Simulationssteuersignal
  
begin
 ps2_dev: entity work.ps2t_dev                      -- vorgegebenes Simulationsmodell 
  port map(run_sim=>run_sim, send=>send_dev, x=>x_dev, y=>y_dev, ps2d=>ps2d, ps2t=>ps2t);

 ps_pc: entity work.ps2t_pc                         -- zu entwerfende Schaltung
  port map (T=>T, I=>I, send=>send_pc, send_ack=>send_ack, DI=>x_pc, DO=>y_pc, ps2d=>ps2d, ps2t=>ps2t);
 
  
  T <= not T after 2500 ns when run_sim else '0';	-- Taktbereitstellung
  ps2d <= 'H'; ps2t <= 'H';						    -- Pullup-Elemente
  
  process
  begin
   I <= '1'; wait for 1 us;                         -- Initialisierung der zu
   I <= '0'; run_sim <= true;                       -- entwerfenden Schaltung
   wait for 200 us;                                 -- Warten auf Bereitschaft
   assert send_ack = '0' report "Sendebestaetigung nicht deaktiviert";
   x_pc <= x"71"; send_pc <= '1', '0' after 80 us;  -- Senden an die Taststur
   wait for 700 us;
   x_dev <= x"4A"; send_dev <= '1', '0' after 80 us;-- Empfang von der Tastatur
   wait for 700 us;
   assert send_ack = '0' report "Sendebestaetigung nicht deaktiviert";
   x_pc <= x"3F"; send_pc <= '1', '0' after 80 us;  -- Senden an die Taststur
   wait for 700 us;
   x_dev <= x"2D"; send_dev <= '1', '0' after 80 us;-- Empfang von der Tastatur
   wait for 700 us;
   run_sim <= false; 
   wait;
  end process;
 end architecture;


  
  
   